//+------------------------------------------------------------------+
//|                                                             .mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 White
#property indicator_color2 White
#property indicator_color3 White
//---- buffers

// 1 Hour CHART
extern int First_Map_TF=PERIOD_H1;
//DiNapoli
extern int K_Period=8;
extern int D_Period=3;
extern int Slowing=3;
//RSI
extern int RSI_Period=13;
extern int RSI_Applied_Price=PRICE_CLOSE;
//EMA
extern int EMA1_Period=5;
extern int EMA1_Mode=MODE_EMA;
extern int EMA1_Applied_Price=PRICE_CLOSE;
extern int EMA2_Period=8;
extern int EMA2_Mode=MODE_EMA;
extern int EMA2_Applied_Price=PRICE_OPEN;
//
extern int Trade_Bar=1;

// Daily CHART
extern int Second_Map_TF=PERIOD_D1;
//DiNapoli
extern int Map2_K_Period=8;
extern int Map2_D_Period=3;
extern int Map2_Slowing=3;
//RSI
extern int Map2_RSI_Period=13;
extern int Map2_RSI_Applied_Price=PRICE_CLOSE;
//EMA
extern int Map2_EMA1_Period=5;
extern int Map2_EMA1_Mode=MODE_EMA;
extern int Map2_EMA1_Applied_Price=PRICE_CLOSE;
extern int Map2_EMA2_Period=8;
extern int Map2_EMA2_Mode=MODE_EMA;
extern int Map2_EMA2_Applied_Price=PRICE_OPEN;
//
extern int Map2_Trade_Bar=1;

//current CHART
extern int    DailyLabel_Size=14;
extern color  DailyLabel_Color=White; 
extern bool   Use_Alert=true;
extern int    CountBars=300;

bool up=false;
bool dn=false;
static datetime last_t=D'1980.01.01';
bool up_b=false;
bool dn_b=false;
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];

int init()
  {
   SetIndexStyle(0,DRAW_ARROW,STYLE_SOLID,4);
   SetIndexStyle(1,DRAW_ARROW,STYLE_SOLID,4);
   SetIndexStyle(2,DRAW_ARROW,STYLE_SOLID,4);
   SetIndexArrow(1,233);
   SetIndexArrow(0,234);
   SetIndexArrow(2,251);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(1,0.0);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexEmptyValue(2,0.0);
   ObjectDelete("TrendLabel");   
   return(0);   
  }
int deinit(){
   Comment("");
   ObjectDelete("TrendLabel");
return(0);
 }
int start()

  {
  
  if(CountBars<0) return(-1);
  if(CountBars>0) CountBars--;
  int limit, counter;
  
   limit=Bars-CountBars;

   PrintTrend();
   
  for (int i=CountBars;i>=0;i--){
      ExtMapBuffer1[i]=0.0;
      ExtMapBuffer2[i]=0.0;
      ExtMapBuffer3[i]=0.0;
      
      double sto1=iCustom(Symbol(),First_Map_TF,"StochasticDiNapoli_v1",K_Period,D_Period,Slowing,0,i+Trade_Bar);
      double sto2=iCustom(Symbol(),First_Map_TF,"StochasticDiNapoli_v1",K_Period,D_Period,Slowing,0,i+Trade_Bar+1);
      double sig1=iCustom(Symbol(),First_Map_TF,"StochasticDiNapoli_v1",K_Period,D_Period,Slowing,1,i+Trade_Bar);
      double sig2=iCustom(Symbol(),First_Map_TF,"StochasticDiNapoli_v1",K_Period,D_Period,Slowing,1,i+Trade_Bar+1);
      double rsi1=iRSI(Symbol(),First_Map_TF,RSI_Period,RSI_Applied_Price,i+Trade_Bar);
      double rsi2=iRSI(Symbol(),First_Map_TF,RSI_Period,RSI_Applied_Price,i+Trade_Bar+1);
      double ema1_1=iMA(Symbol(),First_Map_TF,EMA1_Period,0,EMA1_Mode,EMA1_Applied_Price,i+Trade_Bar);
      double ema1_2=iMA(Symbol(),First_Map_TF,EMA1_Period,0,EMA1_Mode,EMA1_Applied_Price,i+Trade_Bar+1);
      double ema2_1=iMA(Symbol(),First_Map_TF,EMA2_Period,0,EMA2_Mode,EMA2_Applied_Price,i+Trade_Bar);
      double ema2_2=iMA(Symbol(),First_Map_TF,EMA2_Period,0,EMA2_Mode,EMA2_Applied_Price,i+Trade_Bar+1);
      double sto30=iCustom(Symbol(),PERIOD_M30,"StochasticDiNapoli_v1",K_Period,D_Period,Slowing,0,i+Trade_Bar);
      double sig30=iCustom(Symbol(),PERIOD_M30,"StochasticDiNapoli_v1",K_Period,D_Period,Slowing,1,i+Trade_Bar+1);
      double rsi30_1=iRSI(Symbol(),PERIOD_M30,RSI_Period,RSI_Applied_Price,i+Trade_Bar);
      double rsi30_2=iRSI(Symbol(),PERIOD_M30,RSI_Period,RSI_Applied_Price,i+Trade_Bar+1);


      int j=iBarShift(Symbol(),Second_Map_TF,Time[i],false);

      double Map2_sto1=iCustom(Symbol(),Second_Map_TF,"StochasticDiNapoli_v1",Map2_K_Period,Map2_D_Period,Map2_Slowing,0,j+Map2_Trade_Bar);
      double Map2_sto2=iCustom(Symbol(),Second_Map_TF,"StochasticDiNapoli_v1",Map2_K_Period,Map2_D_Period,Map2_Slowing,0,j+Map2_Trade_Bar+1);
      double Map2_sig1=iCustom(Symbol(),Second_Map_TF,"StochasticDiNapoli_v1",Map2_K_Period,Map2_D_Period,Map2_Slowing,1,j+Map2_Trade_Bar);
      double Map2_sig2=iCustom(Symbol(),Second_Map_TF,"StochasticDiNapoli_v1",Map2_K_Period,Map2_D_Period,Map2_Slowing,1,j+Map2_Trade_Bar+1);
      double Map2_rsi1=iRSI(Symbol(),Second_Map_TF,Map2_RSI_Period,Map2_RSI_Applied_Price,j+Map2_Trade_Bar);
      double Map2_rsi2=iRSI(Symbol(),Second_Map_TF,Map2_RSI_Period,Map2_RSI_Applied_Price,j+Map2_Trade_Bar+1);
      double Map2_ema1_1=iMA(Symbol(),Second_Map_TF,Map2_EMA1_Period,0,Map2_EMA1_Mode,Map2_EMA1_Applied_Price,j+Map2_Trade_Bar);
      double Map2_ema1_2=iMA(Symbol(),Second_Map_TF,Map2_EMA1_Period,0,Map2_EMA1_Mode,Map2_EMA1_Applied_Price,j+Map2_Trade_Bar+1);
      double Map2_ema2_1=iMA(Symbol(),Second_Map_TF,Map2_EMA2_Period,0,Map2_EMA2_Mode,Map2_EMA2_Applied_Price,j+Map2_Trade_Bar);
      double Map2_ema2_2=iMA(Symbol(),Second_Map_TF,Map2_EMA2_Period,0,Map2_EMA2_Mode,Map2_EMA2_Applied_Price,j+Map2_Trade_Bar+1);
   
      if (sto1>sig1 && rsi1>50 && ema1_1>ema2_1 &&  
          Map2_sto2>Map2_sig2 && Map2_rsi2>50 && Map2_ema1_1>Map2_ema2_1 &&
          !up){
         ExtMapBuffer2[i]=Low[i]-5*Point;
         up=true;
         dn=false;                 
      }
      if (sto1<sig1 && rsi1<50 && ema1_1<ema2_1 &&  
          Map2_sto2<Map2_sig2 && Map2_rsi2<50 && Map2_ema1_1<Map2_ema2_1 && 
          !dn){
         ExtMapBuffer1[i]=High[i]+5*Point;
         dn=true;
         up=false;                 
      }
      if (up && sto30<sig30 && sto1<sig1){
         up=false;
         dn=false;
         ExtMapBuffer3[i]=High[i]+10*Point;
      }
      if (dn && sto30>sig30 && sto1>sig1){
         up=false;
         dn=false;
         ExtMapBuffer3[i]=Low[i]-10*Point;
      }      
   }   
   
   if (Use_Alert){
      if (ExtMapBuffer2[i]!=0 && ExtMapBuffer1[i]==0 && ExtMapBuffer3[i]==0 && Time[0]>last_t){
         last_t=Time[0];
         Alert("BUY: Mint KEY signal on ",Symbol()," ",Periodo(Period()));
      }
      if (ExtMapBuffer1[i]!=0 && ExtMapBuffer2[i]==0 && ExtMapBuffer3[i]==0 && Time[0]>last_t){
         last_t=Time[0];
         Alert("SELL: Mint KEY signal on ",Symbol()," ",Periodo(Period()));
      }     
      if (ExtMapBuffer3[i]!=0 && ExtMapBuffer1[i]==0 && ExtMapBuffer2[i]==0 && Time[0]>last_t){
         last_t=Time[0];
         Alert("STOP: Mint KEY signal on  ",Symbol()," ",Periodo(Period()));
      }     
       
   }         
   return(0);
  }
  
void PrintTrend()
{
 double EMA5,EMA8,DiNapoli_Stoch,DiNapoli_Signal,RSI;
 string sTrend;
 
   // Rileva Dati D1 //
   EMA5            = iMA(NULL,PERIOD_D1,5,0,MODE_EMA,PRICE_CLOSE,1);
   EMA8            = iMA(NULL,PERIOD_D1,8,0,MODE_EMA,PRICE_OPEN,1);      
   DiNapoli_Stoch  = iCustom(NULL,PERIOD_D1,"StochasticDiNapoli_v1",8,3,3,0,1);
   DiNapoli_Signal = iCustom(NULL,PERIOD_D1,"StochasticDiNapoli_v1",8,3,3,1,1);
   RSI             = iRSI(NULL,PERIOD_D1,13,PRICE_CLOSE,1);

   // Controlla Trend Daily //
   if (EMA5 > EMA8 && DiNapoli_Stoch > DiNapoli_Signal && RSI > 50) { sTrend = "TREND UP"; }
   else 
    if (EMA5 < EMA8 && DiNapoli_Stoch < DiNapoli_Signal && RSI < 50) { sTrend = "TREND DOWN"; }
     else { sTrend = "SIDEWAYS"; }
   
   // Disegna Daily Trend //
   if (ObjectFind("TrendLabel")==-1)
   {
    ObjectCreate("TrendLabel", OBJ_LABEL, 0, 0, 0);
    ObjectSet("TrendLabel", OBJPROP_CORNER, 1);
    ObjectSet("TrendLabel", OBJPROP_XDISTANCE, 10);
    ObjectSet("TrendLabel", OBJPROP_YDISTANCE, 5);   
    ObjectSetText("TrendLabel", sTrend, DailyLabel_Size, "Tahoma", DailyLabel_Color);
   }
}

string Periodo(int TF)
{
 if (TF==1)    { return("M1"); }
 if (TF==5)    { return("M5"); }
 if (TF==15)   { return("M15"); }
 if (TF==30)   { return("M30"); } 
 if (TF==60)   { return("H1"); } 
 if (TF==240)  { return("H4"); } 
 if (TF==1440) { return("D1"); }  
}  

